import rstudio.*;
import java.io.*;

/* **************************************************************************
 * File:           RemoteST1.java
 * First Created:  09.06.2006
 * Last Modified:  12.06.2006
 * Author:         Michael Hufschmidt
 * (C):            Raining Data Corp.
 * **************************************************************************
 * Content / Description / Requirements / Usage:
 *
 * This class enhances the RemoteST by adding a method to load the
 * parameters from an ini file.
 * **************************************************************************/
public class RemoteST1 extends RemoteST {

  public void loadParams(String iniFileName) throws FileNotFoundException,
      IOException {
    // this method reads the properties of the RemoteStudio class
    // from an ini-file, the filename is provided as a parameter.
    // See file RSA_Demo.java for the syntax of the .ini file
    String oPort = "", oServer = "";
    FileReader inifile = new FileReader(iniFileName);
    LineNumberReader linereader = new LineNumberReader(inifile);
    String line = "", param = "", value = "";
    String[] tokens = new String[2];
    while (line != null) {
      line = linereader.readLine();
      if (line != null) {
        if (!(line.trim().startsWith(";") | line.length() == 0)) {
          tokens = line.split("=", 2);
          if (tokens.length > 1) {
            param = tokens[0].trim();
            value = tokens[1].trim();
            if (param.equals("WebServerURL")) {
              this.serverURL = value;
            } else if (param.equals("WebServerScript")) {
              this.serverScript = value;
            } else if (param.equals("OmnisServer")) {
              oServer = value;
            } else if (param.equals("OmnisPort")) {
              oPort = value;
            } else if (param.equals("OmnisLibrary")) {
              this.omnisLibrary = value;
            } else if (param.equals("OmnisClass")) {
              this.omnisClass = value;
            }
            if (oServer.length() < 1) {
              this.omnisServer = oPort;
            } else {
              this.omnisServer = oServer + ":" + oPort;
            }
          }
        }
      }
    }
  }
}
