<?php

/****************************************************************************
* Project:       PHP Remote Studio Applet
* Invoking a Remote Task in Omnis Studio (Version > 4.1) with a PHP Script
*****************************************************************************
* File:          rs_utils.php
* First created: 2004-xx-xx
* Author:        NN
* Last modified: 2006-06-07
* Modified by:   Michael Hufschmidt
* Copyright (C): Raining Data 2004
*****************************************************************************
* Content / Description / Requirements / Usage:
*
* This file contains several utility functions
****************************************************************************/

function isBigEndian() {
  static $sProcType = 0;
  if ($sProcType == 0) {
    $ts = pack("d", 1.2345);
    $ts2 = pack("C8", 0x8D, 0x97, 0x6E, 0x12, 0x83, 0xC0, 0xF3, 0x3F);
    if ($ts == $ts2)
      $sProcType = 1;
    else
      $sProcType = 2;
  }
  return $sProcType -1;
}

function ctocstring(& $stringarray) {
  $cstr = "";
  $count = count($stringarray);
  for ($i = 0; $i < $count; $i ++) {
    $cstr .= $stringarray[$i];
  }
  return $cstr;
}

function cfmxlong($xlong) {
  return ($xlong[0] << 24) | ($xlong[1] << 16) | ($xlong[2] << 8) | ($xlong[3]);
}

// convert binary data (byte values in range 0-255) to decimal number 
// understands different data types and little/big endian order 
function bin2dec($val) {

  // convert to hexadecimal 
  $val = bin2hex($val);

  // double precesion integer coding - go get the bits! 
  $bits = '';
  for ($i = 0; $i < 8; $i ++)
    $bits .= str_pad(base_convert(substr($val, 2 * $i, 2), 16, 2), 8, '0', STR_PAD_LEFT);

  // get sign 
  $sign = (int) substr($bits, 0, 1);

  // get (un)biased exponent 
  $exp = bindec(substr($bits, 1, 11)) - 1023;

  // get fraction 
  $frac = 1;
  $tmp = substr($bits, 12, 52);
  for ($i = 0; $i < 52; $i ++)
    $frac += ((int) substr($tmp, $i, 1)) * pow(2, -1 - $i);

  // calculate final value 
  $val = pow(-1, $sign) * pow(2, $exp) * $frac;

  // return as result 
  return $val;

}

function ctoxlong(& $pData, $lng, $offset) {
  $pData[$offset ++] = ($lng >> 24) & 0xff;
  $pData[$offset ++] = ($lng >> 16) & 0xff;
  $pData[$offset ++] = ($lng >> 8) & 0xff;
  $pData[$offset] = $lng & 0xff;
}

function ctoxreal(& $pData, $lng, $offset) {
  $str = pack("d", $lng);
  if (isBigEndian()) {
    for ($i = 0; $i < 8; $i ++) {
      $pData[$offset ++] = $str[7 - $i];
    }
  } else {
    for ($i = 0; $i < 8; $i ++) {
      $pData[$offset ++] = $str[$i];
    }
  }
}

function cfmxreal($xreal) {
  $str = "";
  if (isBigEndian()) {
    $str[0] = chr($xreal[0]);
    $str[1] = chr($xreal[1]);
    $str[2] = chr($xreal[2]);
    $str[3] = chr($xreal[3]);
    $str[4] = chr($xreal[4]);
    $str[5] = chr($xreal[5]);
    $str[6] = chr($xreal[6]);
    $str[7] = chr($xreal[7]);
  } else {
    $str[0] = chr($xreal[7]);
    $str[1] = chr($xreal[6]);
    $str[2] = chr($xreal[5]);
    $str[3] = chr($xreal[4]);
    $str[4] = chr($xreal[3]);
    $str[5] = chr($xreal[2]);
    $str[6] = chr($xreal[1]);
    $str[7] = chr($xreal[0]);
  }
  $val = bin2dec(ctocstring($str));
  $val = round($val, 7); # Hack to ensure number is rounded correctly
  return $val;
}
?>


